<template>
  <div class="white-block">
    <div class="padding">
      <h3>Дополнительная информация</h3>
    </div>
    <hr/>
    <div class="padding">
      <div class="row">

        <div class="columns four">
          <label for="educationType">Образование</label>
          <multiselect v-model="fieldEducation"
                       name="educationType"
                       :options="educationStatus"
                       :searchable="false"
                       :close-on-select="true"
                       :show-labels="false"
                       placeholder=""
                       id="educationType"
                       :preserve-search="true"
                       label="title"
                       track-by="id"
                       @input="getEducationStatus"
                       :vValidateRules="'required'"
                       v-validate="'required'"
                       :class="getValidateClass('educationType')"
                       :value="typeOfEducation"
                       data-code="educationTypeInvalidFormat, educationTypeNotInAvailableRange"
          >
          </multiselect>
          <validate-message v-show="vErrors.has('educationType')">
            {{ vErrors.first('educationType') }}
          </validate-message>
        </div>

        <div class="columns four">
          <label for="maritalStatus">Семейное положение</label>
          <multiselect v-model="fieldMaritalStatus"
                       name="Выберите семейное положение"
                       :options="familyStatus"
                       :searchable="false"
                       :close-on-select="true"
                       :show-labels="false"
                       placeholder=""
                       id="maritalStatus"
                       :preserve-search="true"
                       label="title"
                       track-by="id"
                       @input="getMaritalStatus"
                       :vValidateRules="'required'"
                       v-validate="'required'"
                       :class="getValidateClass('Выберите семейное положение')"
                       :value="maritalStatus"
                       data-code="maritalStatusInvalidFormat, maritalStatusNotInAvailableRange"
          >
          </multiselect>
          <validate-message v-show="vErrors.has('Выберите семейное положение')">
            {{ vErrors.first('Выберите семейное положение') }}
          </validate-message>
        </div>

        <div class="columns four checkbox">
          <div class="label-profile">Есть ли у Вас дети?</div>
          <input type="radio"
                 name="countChildren"
                 id="children_yes"
                 :checked="clarifyCountOfChildren !== null"
                 v-validate="'required'"
                 @change="changeAmountOfChildren(1)"
                 data-code="numberOfChildrenInvalidFormat, numberOfChildrenNotInAvailableRange"
          />
          <label for="children_yes"><span></span>Да</label>
          <input type="radio"
                 name="countChildren"
                 id="children_no"
                 :checked="clarifyCountOfChildren === '0'"
                 v-validate="'required'"
                 @change="changeAmountOfChildren(0)"
                 data-code="numberOfChildrenInvalidFormat, numberOfChildrenNotInAvailableRange"
          />
          <label for="children_no"><span></span>Нет</label>
          <div class="checkbox-checkbox">
            <validate-message v-show="vErrors.has('countChildren')">
              {{ vErrors.first('countChildren') }}
            </validate-message>
          </div>
        </div>

      </div>
      <div class="row">

        <transition name="slide-fade">
            <div class="columns four" v-if="$user.numberOfChildren ? $user.numberOfChildren !== '0' : $user.numberOfChildren !== null">
              <label for="numberOfChildren">Количество детей</label>
              <input type="text"
                     name="количество детей"
                     id="numberOfChildren"
                     :class="getValidateClass('количество детей')"
                     v-model="$user.numberOfChildren"
                     v-mask="'##'"
                     v-validate="'required'"
                     data-code="numberOfChildrenInvalidFormat, numberOfChildrenNotInAvailableRange"
              />
            <validate-message v-show="vErrors.has('количество детей')">
              {{ vErrors.first('количество детей') }}
            </validate-message>
          </div>
        </transition>

        <div class="columns four checkbox">
          <div class="label-profile">Есть ли у Вас судимость?</div>
          <input type="radio"
                 name="hasPreviousConviction"
                 id="previous_conviction_yes"
                 :value="true"
                 v-model="$user.hasPreviousConviction"
                 v-validate="'required'"
                 data-code="hasPreviousConvictionNotInAvailableRange"
          />
          <label for="previous_conviction_yes"><span></span>Да</label>
          <input type="radio"
                 name="hasPreviousConviction"
                 id="previous_conviction_no"
                 :value="false"
                 v-model="$user.hasPreviousConviction"
                 v-validate="'required'"
                 data-code="hasPreviousConvictionNotInAvailableRange"
          />
          <label for="previous_conviction_no"><span></span>Нет</label>
          <div class="checkbox-checkbox">
            <validate-message v-show="vErrors.has('hasPreviousConviction')">
              {{ vErrors.first('hasPreviousConviction') }}
            </validate-message>
          </div>
        </div>

        <div class="columns four">
          <label for="sourceOfInformation">Откуда Вы о нас узнали?</label>
          <multiselect v-model="fieldSourceOfInformation"
                       :options="sourceOfInformationStatus"
                       :searchable="false"
                       :close-on-select="true"
                       :show-labels="false"
                       placeholder=""
                       id="sourceOfInformation"
                       :preserve-search="true"
                       label="title"
                       track-by="id"
                       @input="getSourceOfInformation"
                       :vValidateRules = "'required'"
                       name="sourceOfInformation"
                       v-validate="'required'"
                       :value="sourceOfInformation"
                       :class="getValidateClass('sourceOfInformation')"
                       data-code="sourceOfInformationInvalidFormat, sourceOfInformationNotInAvailableRange"
          >
          </multiselect>

          <validate-message v-show="vErrors.has('sourceOfInformation')">
            {{ vErrors.first('sourceOfInformation') }}
          </validate-message>
        </div>


      </div>
    </div>
  </div>
</template>

<script>
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import Multiselect from '@/UI/Multiselect'

  export default {
    mixins: [
      UserGetter,
      UserSetter,
      UserErrorText,
      GetValidateClass,
      IndicatorRegistration,
      ErrorHandleMixin
    ],
    data () {
      return {
        fieldEducation: '',
        educationStatus: [
          {id: 1, title: 'Среднее/среднее специальное'},
          {id: 2, title: 'Неполное высшее'},
          {id: 3, title: 'Высшее образование'},
          {id: 4, title: 'Ученая степень'}
        ],
        fieldMaritalStatus: '',
        familyStatus: [
          {id: 1, title: 'Замужем/женат'},
          {id: 2, title: 'Не замужем/холост'},
          {id: 3, title: 'Разведен(а)'},
          {id: 4, title: 'Вдова/Вдовец'}
        ],
        countChildren: '',
        fieldSourceOfInformation: '',
        sourceOfInformationStatus: [
          {id: 1, title: 'Социальные сети'},
          {id: 2, title: 'Рассылка на электронную почту'},
          {id: 3, title: 'Поисковые системы (яндекс, google и т.п.)'},
          {id: 4, title: 'Реклама на ТВ'},
          {id: 5, title: 'Рекомендации друзей, знакомых'},
          {id: 6, title: 'Реклама на радио'},
          {id: 7, title: 'Другое'}
        ]
      }
    },
    computed: {
      clarifyCountOfChildren () {
        return this.$user.numberOfChildren
      },
      maritalStatus () {
        this.fieldMaritalStatus = this.familyStatus[this.$user.maritalStatus - 1]
      },
      typeOfEducation () {
        this.fieldEducation = this.educationStatus[this.$user.educationType - 1]
      },
      sourceOfInformation () {
        this.fieldSourceOfInformation = this.sourceOfInformationStatus[this.$user.sourceOfInformation - 1]
      }
    },
    methods: {
      changeAmountOfChildren (arg) {
        (arg === 0) ? this.$user.numberOfChildren = '0' : this.$user.numberOfChildren = '';
      },
      getEducationStatus (arg) {
        this.$user.educationType = arg.id
      },
      getMaritalStatus (arg) {
        this.$user.maritalStatus = arg.id
      },
      getSourceOfInformation (arg) {
        this.$user.sourceOfInformation = arg.id
      }
    },
    components: {
      ValidateMessage,
      Multiselect
    },
    updated () {
      this.$user.validate.step3.additionalInfo = Object.keys(this.$validator.flags).reduce((acc, item) => acc && this.$validator.flags[item].valid, true)
    },
    name: 'additional-information'
  }
</script>

<style scoped lang="scss">
  .slide-fade-enter-active {
    transition: all .3s ease;
  }

  .slide-fade-leave-active {
    transition: all .3s ease;
  }

  .slide-fade-enter, .slide-fade-leave-to {
    transform: translateY(10px);
    opacity: 0;
  }

  .slide-fade-leave-to {
    transform: translateY(10px);
    opacity: 0;
  }

  .checkbox-checkbox {
    margin-top: 30px;
    margin-bottom: -30px;
  }
</style>

